<?php
declare(strict_types=1);

namespace mirzaev\baza;

// Files of the project
use mirzaev\baza\enumerations\architecture;


// Built-in libraries
use DomainExceptionn as exception_domain;

/**
 * Core
 *
 * @package mirzaev/baza
 *
 * @method void architecture() Get PHP distribution architecture
 * @see https://www.php.net/manual/en/function.pack.php#109382
 *
 * @license http://www.wtfpl.net/ Do What The Fuck You Want To Public License
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */

final class core
{
	public static function architecture(): ?architecture {
		return match(PHP_INT_SIZE) {
			4 => architecture::x86,
			8 => architecture::x86_64,
			default => throw new exception_domain('Failed to determinate the system architecture'),
		};
	}
}
